'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * CSS Selector object
 */

var Selector =

/**
 * Constructor
 *
 * @param  {Object} tokens  object with type: 'selector' and array of nodes
 */
function Selector(tokens) {
	_classCallCheck(this, Selector);

	if ((typeof tokens === 'undefined' ? 'undefined' : _typeof(tokens)) !== 'object' || tokens.type !== 'selector' || !tokens.nodes || !tokens.nodes.length) {
		throw new TypeError('Selector should be constructed with a proper parsed token object.');
	}

	// pull out just the nodes
	tokens = tokens.nodes;

	var specificity = { a: 0, b: 0, c: 0, d: 0 };

	// calculate the specificity @see: https://www.w3.org/TR/2009/CR-CSS2-20090908/cascade.html#specificity
	for (var i = 0; i < tokens.length; i++) {
		if (tokens[i].specificityType) {
			specificity[tokens[i].specificityType]++;
		}
	}

	Object.assign(this, { tokens: tokens, specificity: specificity });
};

exports.default = Selector;