'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

// Generated automatically by nearley
// http://github.com/Hardmath123/nearley
(function () {
  function id(x) {
    return x[0];
  }

  // collapse nested arrays of strings/objects into a single concatenated string
  function collapse(d) {
    var raw = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (typeof d === 'string') return d;else if (d && raw && typeof d.raw === 'string') return d.raw;else if (d && !raw && typeof d.parsed === 'string') return d.parsed;else if (!Array.isArray(d)) return '';

    var out = '';
    for (var i = 0; i < d.length; i++) {
      out += collapse(d[i], raw);
    }return out;
  }

  // wrapper for clarity
  function collapseRaw(d) {
    return collapse(d, true);
  }

  // collect nested arrays of objects into a flat array
  function collectObjects(d) {
    var objs = [];
    for (var i = 0; i < d.length; i++) {
      if (Array.isArray(d[i])) {
        objs = objs.concat(collectObjects(d[i]));
      } else if (d[i] && _typeof(d[i]) === 'object') {
        objs.push(d[i]);
      }
    }
    return objs;
  }

  var combinatorTypes = {
    '+': 'adjacentSiblingCombinator',
    '>': 'childCombinator',
    '~': 'generalSiblingCombinator',
    ' ': 'descendantCombinator'
  };
  var grammar = {
    Lexer: undefined,
    ParserRules: [{ "name": "selectors_group$ebnf$1", "symbols": [] }, { "name": "selectors_group$ebnf$1$subexpression$1", "symbols": ["_", { "literal": "," }, "_", "selector"] }, { "name": "selectors_group$ebnf$1", "symbols": ["selectors_group$ebnf$1", "selectors_group$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "selectors_group", "symbols": ["_", "selector", "selectors_group$ebnf$1", "_"], "postprocess": function postprocess(d) {
        var selectors = [d[1]];
        // are there additional selectors?
        if (d[2] && d[2].length) {
          for (var i = 0; i < d[2].length; i++) {
            selectors.push(d[2][i][3]);
          }
        }
        return { type: 'selectorsGroup', selectors: selectors };
      } }, { "name": "selector$ebnf$1", "symbols": [] }, { "name": "selector$ebnf$1$subexpression$1", "symbols": ["combinator", "simple_selector_sequence"] }, { "name": "selector$ebnf$1", "symbols": ["selector$ebnf$1", "selector$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "selector", "symbols": ["simple_selector_sequence", "selector$ebnf$1"], "postprocess": function postprocess(d) {
        return { type: 'selector', nodes: collectObjects(d) };
      } }, { "name": "combinator$subexpression$1", "symbols": ["_", /[+>~]/, "_"] }, { "name": "combinator$subexpression$1", "symbols": ["__"] }, { "name": "combinator", "symbols": ["combinator$subexpression$1"], "postprocess": function postprocess(d, location) {
        return { type: combinatorTypes[d[0][1] || ' '], location: location, raw: collapseRaw(d), specificityType: null };
      } }, { "name": "simple_selector_sequence$subexpression$1", "symbols": ["type_selector"] }, { "name": "simple_selector_sequence$subexpression$1", "symbols": ["universal"] }, { "name": "simple_selector_sequence$subexpression$1", "symbols": ["simple_selector"] }, { "name": "simple_selector_sequence$ebnf$1", "symbols": [] }, { "name": "simple_selector_sequence$ebnf$1$subexpression$1$ebnf$1", "symbols": ["comment"], "postprocess": id }, { "name": "simple_selector_sequence$ebnf$1$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "simple_selector_sequence$ebnf$1$subexpression$1", "symbols": ["simple_selector_sequence$ebnf$1$subexpression$1$ebnf$1", "simple_selector"] }, { "name": "simple_selector_sequence$ebnf$1", "symbols": ["simple_selector_sequence$ebnf$1", "simple_selector_sequence$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "simple_selector_sequence", "symbols": ["simple_selector_sequence$subexpression$1", "simple_selector_sequence$ebnf$1"] }, { "name": "simple_selector", "symbols": ["hash"] }, { "name": "simple_selector", "symbols": ["class"] }, { "name": "simple_selector", "symbols": ["attrib"] }, { "name": "simple_selector", "symbols": ["pseudo"] }, { "name": "simple_selector", "symbols": ["negation"] }, { "name": "universal$ebnf$1", "symbols": ["namespace_prefix"], "postprocess": id }, { "name": "universal$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "universal", "symbols": ["universal$ebnf$1", { "literal": "*" }], "postprocess": function postprocess(d, location) {
        return { type: 'universalSelector', namespace: d[0] ? d[0].name : d[0], location: location, raw: collapseRaw(d), specificityType: null };
      } }, { "name": "type_selector$ebnf$1", "symbols": ["namespace_prefix"], "postprocess": id }, { "name": "type_selector$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "type_selector", "symbols": ["type_selector$ebnf$1", "ident"], "postprocess": function postprocess(d, location) {
        return { type: 'typeSelector', namespace: d[0] ? d[0].name : d[0], name: collapse(d[1]), location: location, raw: collapseRaw(d), specificityType: 'd' };
      } }, { "name": "hash", "symbols": [{ "literal": "#" }, "name"], "postprocess": function postprocess(d, location) {
        return { type: 'idSelector', name: collapse(d[1]), location: location, raw: collapseRaw(d), specificityType: 'b' };
      } }, { "name": "class", "symbols": [{ "literal": "." }, "ident"], "postprocess": function postprocess(d, location) {
        return { type: 'classSelector', name: collapse(d[1]), location: location, raw: collapseRaw(d), specificityType: 'c' };
      } }, { "name": "attrib$ebnf$1", "symbols": ["namespace_prefix"], "postprocess": id }, { "name": "attrib$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "attrib$ebnf$2$subexpression$1$ebnf$1", "symbols": [/[~|^$*]/], "postprocess": id }, { "name": "attrib$ebnf$2$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "attrib$ebnf$2$subexpression$1$subexpression$1", "symbols": ["ident"] }, { "name": "attrib$ebnf$2$subexpression$1$subexpression$1", "symbols": ["string"] }, { "name": "attrib$ebnf$2$subexpression$1", "symbols": ["attrib$ebnf$2$subexpression$1$ebnf$1", { "literal": "=" }, "_", "attrib$ebnf$2$subexpression$1$subexpression$1"] }, { "name": "attrib$ebnf$2", "symbols": ["attrib$ebnf$2$subexpression$1"], "postprocess": id }, { "name": "attrib$ebnf$2", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "attrib", "symbols": [{ "literal": "[" }, "_", "attrib$ebnf$1", "ident", "_", "attrib$ebnf$2", { "literal": "]" }], "postprocess": function postprocess(d, location) {
        var obj = { namespace: d[2] ? d[2].name : d[2], name: collapse(d[3]), location: location, raw: collapseRaw(d), specificityType: 'c' };
        if (d[5] && d[5].length) {
          obj.type = 'attributeValueSelector';
          obj.operator = (d[5][0] || '') + '=';
          obj.value = collapse(d[5][3][0]);
        } else {
          obj.type = 'attributePresenceSelector';
        }
        return obj;
      } }, { "name": "pseudo$ebnf$1", "symbols": [{ "literal": ":" }], "postprocess": id }, { "name": "pseudo$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "pseudo$subexpression$1", "symbols": ["ident"] }, { "name": "pseudo$subexpression$1", "symbols": ["functional_pseudo"] }, { "name": "pseudo", "symbols": [{ "literal": ":" }, "pseudo$ebnf$1", "pseudo$subexpression$1"], "postprocess": function postprocess(d, location, reject) {
        // reject :not()
        if (d[2][0].function === 'not') {
          return reject;
        }
        var obj = { name: d[2][0].function || collapse(d[2][0]), location: location, raw: collapseRaw(d) };
        // pseudo element?
        if (d[1] || ['before', 'after', 'first-line', 'first-letter'].indexOf(obj.name) !== -1) {
          // pseudo elements should not have a function
          if (d[2][0].function) {
            return reject;
          }
          obj.type = 'pseudoElementSelector';
          obj.specificityType = 'd';
        } else {
          obj.type = 'pseudoClassSelector';
          obj.specificityType = 'c';
          obj.expression = d[2][0].expression || null;
          obj.expressionRaw = d[2][0].expressionRaw || null;
        }
        return obj;
      } }, { "name": "negation", "symbols": [{ "literal": ":" }, /[nN]/, /[oO]/, /[tT]/, { "literal": "(" }, "_", "negation_arg", "_", { "literal": ")" }], "postprocess": function postprocess(d, location) {
        return { type: 'negationSelector', selectors: d[6], location: location, raw: collapseRaw(d), specificityType: null };
      } }, { "name": "namespace_prefix$ebnf$1$subexpression$1", "symbols": ["ident"] }, { "name": "namespace_prefix$ebnf$1$subexpression$1", "symbols": [{ "literal": "*" }] }, { "name": "namespace_prefix$ebnf$1", "symbols": ["namespace_prefix$ebnf$1$subexpression$1"], "postprocess": id }, { "name": "namespace_prefix$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "namespace_prefix", "symbols": ["namespace_prefix$ebnf$1", { "literal": "|" }], "postprocess": function postprocess(d) {
        return { name: collapse(d[0]), raw: collapseRaw(d) };
      } }, { "name": "functional_pseudo", "symbols": ["ident", { "literal": "(" }, "_", "expression", "_", { "literal": ")" }], "postprocess": function postprocess(d) {
        return { function: collapse(d[0]).toLowerCase(), expression: collapse(d[3]), raw: collapseRaw(d), expressionRaw: collapseRaw(d[3]) };
      } }, { "name": "negation_arg", "symbols": ["type_selector"] }, { "name": "negation_arg", "symbols": ["universal"] }, { "name": "negation_arg", "symbols": ["hash"] }, { "name": "negation_arg", "symbols": ["class"] }, { "name": "negation_arg", "symbols": ["attrib"] }, { "name": "negation_arg", "symbols": ["pseudo"] }, { "name": "expression", "symbols": ["string"] }, { "name": "expression", "symbols": ["ident"] }, { "name": "expression", "symbols": ["nth"] }, { "name": "ident$ebnf$1", "symbols": [{ "literal": "-" }], "postprocess": id }, { "name": "ident$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "ident$ebnf$2", "symbols": [] }, { "name": "ident$ebnf$2", "symbols": ["ident$ebnf$2", "nmchar"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "ident", "symbols": ["ident$ebnf$1", "nmstart", "ident$ebnf$2"] }, { "name": "name$ebnf$1", "symbols": ["nmchar"] }, { "name": "name$ebnf$1", "symbols": ["name$ebnf$1", "nmchar"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "name", "symbols": ["name$ebnf$1"] }, { "name": "nmstart", "symbols": [/[_a-zA-Z]/] }, { "name": "nmstart", "symbols": ["nonascii"] }, { "name": "nmstart", "symbols": ["escape"] }, { "name": "nonascii", "symbols": [/[^\0-\177]/] }, { "name": "unicode$subexpression$1$ebnf$1", "symbols": ["hex"], "postprocess": id }, { "name": "unicode$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode$subexpression$1$ebnf$2", "symbols": ["hex"], "postprocess": id }, { "name": "unicode$subexpression$1$ebnf$2", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode$subexpression$1$ebnf$3", "symbols": ["hex"], "postprocess": id }, { "name": "unicode$subexpression$1$ebnf$3", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode$subexpression$1$ebnf$4", "symbols": ["hex"], "postprocess": id }, { "name": "unicode$subexpression$1$ebnf$4", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode$subexpression$1$ebnf$5", "symbols": ["hex"], "postprocess": id }, { "name": "unicode$subexpression$1$ebnf$5", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode$subexpression$1", "symbols": ["hex", "unicode$subexpression$1$ebnf$1", "unicode$subexpression$1$ebnf$2", "unicode$subexpression$1$ebnf$3", "unicode$subexpression$1$ebnf$4", "unicode$subexpression$1$ebnf$5"] }, { "name": "unicode$ebnf$1$subexpression$1$string$1", "symbols": [{ "literal": "\r" }, { "literal": "\n" }], "postprocess": function joiner(d) {
        return d.join('');
      } }, { "name": "unicode$ebnf$1$subexpression$1", "symbols": ["unicode$ebnf$1$subexpression$1$string$1"] }, { "name": "unicode$ebnf$1$subexpression$1", "symbols": ["space"] }, { "name": "unicode$ebnf$1", "symbols": ["unicode$ebnf$1$subexpression$1"], "postprocess": id }, { "name": "unicode$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "unicode", "symbols": [{ "literal": "\\" }, "unicode$subexpression$1", "unicode$ebnf$1"], "postprocess": function postprocess(d) {
        return { parsed: String.fromCodePoint(parseInt(collapse(d[1]), 16)), raw: collapse(d) };
      } }, { "name": "escape", "symbols": ["unicode"] }, { "name": "escape", "symbols": [{ "literal": "\\" }, /[^\n\r\f0-9a-fA-F]/], "postprocess": function postprocess(d) {
        return { parsed: d[1], raw: collapseRaw(d) };
      } }, { "name": "escaped_nl", "symbols": [{ "literal": "\\" }, "nl"], "postprocess": function postprocess(d) {
        return { parsed: d[1], raw: collapseRaw(d) };
      } }, { "name": "nmchar", "symbols": [/[_a-zA-Z0-9-]/] }, { "name": "nmchar", "symbols": ["nonascii"] }, { "name": "nmchar", "symbols": ["escape"] }, { "name": "num$ebnf$1", "symbols": [/[0-9]/] }, { "name": "num$ebnf$1", "symbols": ["num$ebnf$1", /[0-9]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "num", "symbols": ["num$ebnf$1"] }, { "name": "num$ebnf$2", "symbols": [] }, { "name": "num$ebnf$2", "symbols": ["num$ebnf$2", /[0-9]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "num$ebnf$3", "symbols": [/[0-9]/] }, { "name": "num$ebnf$3", "symbols": ["num$ebnf$3", /[0-9]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "num", "symbols": ["num$ebnf$2", { "literal": "." }, "num$ebnf$3"] }, { "name": "int$ebnf$1", "symbols": [/[0-9]/] }, { "name": "int$ebnf$1", "symbols": ["int$ebnf$1", /[0-9]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "int", "symbols": ["int$ebnf$1"] }, { "name": "nth$subexpression$1$ebnf$1", "symbols": [/[+-]/], "postprocess": id }, { "name": "nth$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "nth$subexpression$1$ebnf$2", "symbols": ["int"], "postprocess": id }, { "name": "nth$subexpression$1$ebnf$2", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "nth$subexpression$1$ebnf$3$subexpression$1", "symbols": ["_", /[+-]/, "_", "int"] }, { "name": "nth$subexpression$1$ebnf$3", "symbols": ["nth$subexpression$1$ebnf$3$subexpression$1"], "postprocess": id }, { "name": "nth$subexpression$1$ebnf$3", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "nth$subexpression$1", "symbols": ["nth$subexpression$1$ebnf$1", "nth$subexpression$1$ebnf$2", /[nN]/, "nth$subexpression$1$ebnf$3"] }, { "name": "nth$subexpression$1$ebnf$4", "symbols": [/[+-]/], "postprocess": id }, { "name": "nth$subexpression$1$ebnf$4", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "nth$subexpression$1", "symbols": ["nth$subexpression$1$ebnf$4", "int"] }, { "name": "nth", "symbols": ["nth$subexpression$1"], "postprocess": function postprocess(d) {
        return { parsed: collapse(d).replace(/[ \n\r\t\f]+/g, ''), raw: collapseRaw(d) };
      } }, { "name": "hex", "symbols": [/[0-9a-fA-F]/] }, { "name": "string$subexpression$1", "symbols": ["string1"] }, { "name": "string$subexpression$1", "symbols": ["string2"] }, { "name": "string", "symbols": ["string$subexpression$1"], "postprocess": function postprocess(d) {
        return d[0][0];
      } }, { "name": "string1$ebnf$1", "symbols": [] }, { "name": "string1$ebnf$1$subexpression$1", "symbols": [/[^\n\r\f\\"]/] }, { "name": "string1$ebnf$1$subexpression$1", "symbols": ["escaped_nl"] }, { "name": "string1$ebnf$1$subexpression$1", "symbols": ["nonascii"] }, { "name": "string1$ebnf$1$subexpression$1", "symbols": ["escape"] }, { "name": "string1$ebnf$1", "symbols": ["string1$ebnf$1", "string1$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "string1", "symbols": [{ "literal": "\"" }, "string1$ebnf$1", { "literal": "\"" }], "postprocess": function postprocess(d) {
        return { parsed: collapse(d[1]), raw: collapseRaw(d) };
      } }, { "name": "string2$ebnf$1", "symbols": [] }, { "name": "string2$ebnf$1$subexpression$1", "symbols": [/[^\n\r\f\\']/] }, { "name": "string2$ebnf$1$subexpression$1", "symbols": ["escaped_nl"] }, { "name": "string2$ebnf$1$subexpression$1", "symbols": ["nonascii"] }, { "name": "string2$ebnf$1$subexpression$1", "symbols": ["escape"] }, { "name": "string2$ebnf$1", "symbols": ["string2$ebnf$1", "string2$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "string2", "symbols": [{ "literal": "'" }, "string2$ebnf$1", { "literal": "'" }], "postprocess": function postprocess(d) {
        return { parsed: collapse(d[1]), raw: collapseRaw(d) };
      } }, { "name": "nl", "symbols": [{ "literal": "\n" }] }, { "name": "nl$string$1", "symbols": [{ "literal": "\r" }, { "literal": "\n" }], "postprocess": function joiner(d) {
        return d.join('');
      } }, { "name": "nl", "symbols": ["nl$string$1"] }, { "name": "nl", "symbols": [{ "literal": "\r" }] }, { "name": "nl", "symbols": [{ "literal": "\f" }] }, { "name": "dimension", "symbols": ["num", "ident"] }, { "name": "space", "symbols": [/[ \n\r\t\f]/] }, { "name": "_$ebnf$1", "symbols": [] }, { "name": "_$ebnf$1$subexpression$1$ebnf$1", "symbols": ["comment"], "postprocess": id }, { "name": "_$ebnf$1$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "_$ebnf$1$subexpression$1", "symbols": ["_$ebnf$1$subexpression$1$ebnf$1", "space"] }, { "name": "_$ebnf$1", "symbols": ["_$ebnf$1", "_$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "_$ebnf$2", "symbols": ["comment"], "postprocess": id }, { "name": "_$ebnf$2", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "_", "symbols": ["_$ebnf$1", "_$ebnf$2"] }, { "name": "__$ebnf$1$subexpression$1$ebnf$1", "symbols": ["comment"], "postprocess": id }, { "name": "__$ebnf$1$subexpression$1$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "__$ebnf$1$subexpression$1", "symbols": ["__$ebnf$1$subexpression$1$ebnf$1", "space"] }, { "name": "__$ebnf$1", "symbols": ["__$ebnf$1$subexpression$1"] }, { "name": "__$ebnf$1$subexpression$2$ebnf$1", "symbols": ["comment"], "postprocess": id }, { "name": "__$ebnf$1$subexpression$2$ebnf$1", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "__$ebnf$1$subexpression$2", "symbols": ["__$ebnf$1$subexpression$2$ebnf$1", "space"] }, { "name": "__$ebnf$1", "symbols": ["__$ebnf$1", "__$ebnf$1$subexpression$2"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "__$ebnf$2", "symbols": ["comment"], "postprocess": id }, { "name": "__$ebnf$2", "symbols": [], "postprocess": function postprocess(d) {
        return null;
      } }, { "name": "__", "symbols": ["__$ebnf$1", "__$ebnf$2"] }, { "name": "comment$string$1", "symbols": [{ "literal": "/" }, { "literal": "*" }], "postprocess": function joiner(d) {
        return d.join('');
      } }, { "name": "comment$ebnf$1", "symbols": [] }, { "name": "comment$ebnf$1", "symbols": ["comment$ebnf$1", /[^*]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "comment$ebnf$2", "symbols": [{ "literal": "*" }] }, { "name": "comment$ebnf$2", "symbols": ["comment$ebnf$2", { "literal": "*" }], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "comment$ebnf$3", "symbols": [] }, { "name": "comment$ebnf$3$subexpression$1$ebnf$1", "symbols": [] }, { "name": "comment$ebnf$3$subexpression$1$ebnf$1", "symbols": ["comment$ebnf$3$subexpression$1$ebnf$1", /[^*]/], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "comment$ebnf$3$subexpression$1$ebnf$2", "symbols": [{ "literal": "*" }] }, { "name": "comment$ebnf$3$subexpression$1$ebnf$2", "symbols": ["comment$ebnf$3$subexpression$1$ebnf$2", { "literal": "*" }], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "comment$ebnf$3$subexpression$1", "symbols": [/[^*\/]/, "comment$ebnf$3$subexpression$1$ebnf$1", "comment$ebnf$3$subexpression$1$ebnf$2"] }, { "name": "comment$ebnf$3", "symbols": ["comment$ebnf$3", "comment$ebnf$3$subexpression$1"], "postprocess": function arrpush(d) {
        return d[0].concat([d[1]]);
      } }, { "name": "comment", "symbols": ["comment$string$1", "comment$ebnf$1", "comment$ebnf$2", "comment$ebnf$3", { "literal": "/" }] }],
    ParserStart: "selectors_group"
  };
  if (typeof module !== 'undefined' && typeof module.exports !== 'undefined') {
    module.exports = grammar;
  } else {
    window.grammar = grammar;
  }
})();